from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, File, String, Float

Confounder_V0_1_0 = CommandToolBuilder(tool="Confounder", base_command=["Confounder"], inputs=[ToolInput(tag="in_v", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="verbose")), ToolInput(tag="in_syntax", input_type=Boolean(optional=True), prefix="-syntax", doc=InputDocumentation(doc="strong syntax control in input files")), ToolInput(tag="in_verbose", input_type=Int(optional=True), prefix="-verbose", doc=InputDocumentation(doc="verbose")), ToolInput(tag="in_s", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="no output to stdout")), ToolInput(tag="in_silent", input_type=Int(optional=True), prefix="-silent", doc=InputDocumentation(doc="no output to stdout")), ToolInput(tag="in_bin", input_type=Int(optional=True), prefix="-bin", doc=InputDocumentation(doc="bin size for input averaging")), ToolInput(tag="in_clear", input_type=Int(optional=True), prefix="-clear", doc=InputDocumentation(doc="force binary profile preparation")), ToolInput(tag="in_force_binary_profile", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="force  binary profile preparation")), ToolInput(tag="in_cfg", input_type=File(optional=True), prefix="-cfg", doc=InputDocumentation(doc="config file")), ToolInput(tag="in_prof_path", input_type=File(optional=True), prefix="-profPath", doc=InputDocumentation(doc="path for binary profiles")), ToolInput(tag="in_track_path", input_type=File(optional=True), prefix="-trackPath", doc=InputDocumentation(doc="path for tracks")), ToolInput(tag="in_res_path", input_type=File(optional=True), prefix="-resPath", doc=InputDocumentation(doc="path for results")), ToolInput(tag="in_confounder", input_type=File(optional=True), prefix="-confounder", doc=InputDocumentation(doc="confounder filename")), ToolInput(tag="in_statistics", input_type=File(optional=True), prefix="-statistics", doc=InputDocumentation(doc="cumulative file with statistics")), ToolInput(tag="in_params", input_type=File(optional=True), prefix="-params", doc=InputDocumentation(doc="cumulative file with parameters")), ToolInput(tag="in_log", input_type=File(optional=True), prefix="-log", doc=InputDocumentation(doc="cumulative log-file")), ToolInput(tag="in_chrom", input_type=File(optional=True), prefix="-chrom", doc=InputDocumentation(doc="chromosome file")), ToolInput(tag="in_bufsize", input_type=Int(optional=True), prefix="-BufSize", doc=InputDocumentation(doc="Buffer Size")), ToolInput(tag="in_bp_type", input_type=File(optional=True), prefix="-bpType", doc=InputDocumentation(doc="The value used as a score for BroadPeak input file")), ToolInput(tag="in_pc_or_profile", input_type=String(optional=True), prefix="-pcorProfile", doc=InputDocumentation(doc="Track for partial correlation")), ToolInput(tag="in_na", input_type=Boolean(optional=True), prefix="-NA", doc=InputDocumentation(doc="use NA values as unknown and fill them by noise")), ToolInput(tag="in_threshold", input_type=Int(optional=True), prefix="-threshold", doc=InputDocumentation(doc="threshold for input data for removing too small values: 0..250")), ToolInput(tag="in_kernel_sigma", input_type=Float(optional=True), prefix="-kernelSigma", doc=InputDocumentation(doc="Kernel width")), ToolInput(tag="in_w_size", input_type=Int(optional=True), prefix="-wSize", doc=InputDocumentation(doc="Window size")), ToolInput(tag="in_max_na", input_type=Float(optional=True), prefix="-maxNA", doc=InputDocumentation(doc="Max number of NA values in window (percent)")), ToolInput(tag="in_max_zero", input_type=Float(optional=True), prefix="-maxZero", doc=InputDocumentation(doc="Max number of zero values in window (percent)")), ToolInput(tag="in_n_shuffle", input_type=Int(optional=True), prefix="-nShuffle", doc=InputDocumentation(doc="Number of shuffles for background calculation")), ToolInput(tag="in_sp", input_type=Boolean(optional=True), prefix="-sp", doc=InputDocumentation(doc="the data is sparce")), ToolInput(tag="in_out_spectr", input_type=Int(optional=True), prefix="-outSpectr", doc=InputDocumentation(doc="write fourier spectrums")), ToolInput(tag="in_out_chrom", input_type=Int(optional=True), prefix="-outChrom", doc=InputDocumentation(doc="write statistics by chromosomes")), ToolInput(tag="in_write_distr", input_type=String(optional=True), prefix="-writeDistr", doc=InputDocumentation(doc="write foreground and background distributions")), ToolInput(tag="in_write_r_script", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="write R script for the result presentation")), ToolInput(tag="in_cross_width", input_type=Boolean(optional=True), prefix="-crossWidth", doc=InputDocumentation(doc="Width of cross-correlation plot")), ToolInput(tag="in_distances", input_type=Boolean(optional=True), prefix="-Distances", doc=InputDocumentation(doc="Write distance correlations")), ToolInput(tag="in_lc", input_type=Boolean(optional=True), prefix="-lc", doc=InputDocumentation(doc="produce profile correlation")), ToolInput(tag="in_lc_scale", input_type=String(optional=True), prefix="-LCScale", doc=InputDocumentation(doc="Local correlation scale: LOG | LIN")), ToolInput(tag="in_l_fdr", input_type=Float(optional=True), prefix="-L_FDR", doc=InputDocumentation(doc="threshold on left FDR when write the local correlation")), ToolInput(tag="in_r_fdr", input_type=Float(optional=True), prefix="-R_FDR", doc=InputDocumentation(doc="threshold on right FDR when write the local correlation")), ToolInput(tag="in_out_res", input_type=File(optional=True), prefix="-outRes", doc=InputDocumentation(doc="format for results in statistics file"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Confounder_V0_1_0().translate("wdl", allow_empty_container=True)

